/**

AEncodeProperties.cpp: implementation of the AEncodeProperties class.

$Id: AEncodeProperties.cpp,v 1.3 2001/07/26 19:28:49 robux4 Exp $ 
$Name:  $ 

$Log: AEncodeProperties.cpp,v $
Revision 1.3  2001/07/26 19:28:49  robux4
Added CVS tags
 

*/

#if !defined(STRICT)
#define STRICT
#endif // !defined(STRICT)

#include <windows.h>
#include <windowsx.h>
#include <shlobj.h>
#include <assert.h>

#include "resource.h"
#include "AOut.h"
//#include "AParameters/AParameters.h"
#include "AEncodeProperties.h"

const unsigned int AEncodeProperties::the_Bitrates[18] = {320, 256, 224, 192, 160, 144, 128, 112, 96, 80, 64, 56, 48, 40, 32, 24, 16, 8 };
const unsigned int AEncodeProperties::the_MPEG1_Bitrates[14] = {320, 256, 224, 192, 160, 128, 112, 96, 80, 64, 56, 48, 40, 32 };
const unsigned int AEncodeProperties::the_MPEG2_Bitrates[14] = {160, 144, 128, 112, 96, 80, 64, 56, 48, 40, 32, 24, 16, 8};
const unsigned int AEncodeProperties::the_ChannelModes[] = {BE_MP3_MODE_MONO, BE_MP3_MODE_STEREO, BE_MP3_MODE_JSTEREO, BE_MP3_MODE_DUALCHANNEL };
//const char         AEncodeProperties::the_Presets[][13] = {"None", "CD", "Studio", "Hi-Fi", "Phone", "Voice", "Radio", "Tape", "FM", "AM", "SW"};
const LAME_QUALTIY_PRESET AEncodeProperties::the_Presets[] = {LQP_NOPRESET, LQP_NORMAL_QUALITY, LQP_LOW_QUALITY, LQP_HIGH_QUALITY, LQP_VOICE_QUALITY, LQP_PHONE, LQP_SW, LQP_AM, LQP_FM, LQP_VOICE, LQP_RADIO, LQP_TAPE, LQP_HIFI, LQP_CD, LQP_STUDIO};
const unsigned int AEncodeProperties::the_SamplingFreqs[9] = { 48000, 44100, 32000, 24000, 22050, 16000, 12000, 11025, 8000 };

//int AEncodeProperties::tst = 0;


static UINT CALLBACK DLLFindCallback(
  HWND hdlg,      // handle to child dialog box
  UINT uiMsg,     // message identifier
  WPARAM wParam,  // message parameter
  LPARAM lParam   // message parameter
  )
{
	UINT result = 0;

	switch (uiMsg)
	{
		case WM_NOTIFY:
			OFNOTIFY * info = (OFNOTIFY *)lParam;
			if (info->hdr.code == CDN_FILEOK)
			{
				result = 1; // by default we don't accept the file

				// Check if the selected file is a valid DLL with all the required functions
				ALameDLL * tstFile = new ALameDLL;
				if (tstFile != NULL)
				{
					if (tstFile->Load(info->lpOFN->lpstrFile))
					{
						result = 0;
					}

					delete tstFile;
				}

				if (result == 1)
				{
					TCHAR output[250];
					::LoadString(AOut::GetInstance(),IDS_STRING_DLL_UNRECOGNIZED,output,250);
					MessageBox( hdlg, output, "Winamp MP3 Output",MB_OK);
					SetWindowLong(hdlg, DWL_MSGRESULT , -100);
				}
			}
	}

	return result;
}

static int CALLBACK BrowseFolderCallbackroc(
    HWND hwnd,
    UINT uMsg,
    LPARAM lParam,
    LPARAM lpData
    )
{
	AEncodeProperties * the_prop;
	the_prop = (AEncodeProperties *) lpData;


	if (uMsg == BFFM_INITIALIZED)
	{
//		char FolderName[MAX_PATH];
//		SHGetPathFromIDList((LPITEMIDLIST) lParam,FolderName);
//ADbg tst;
//tst.OutPut("init folder to %s ",the_prop->GetOutputDirectory());
//		CreateFile();
		::SendMessage(hwnd, BFFM_SETSELECTION, (WPARAM)TRUE, (LPARAM)the_prop->GetOutputDirectory());
	}/* else if (uMsg == BFFM_SELCHANGED)
	{
		// verify that the folder is writable
//		::SendMessage(hwnd, BFFM_ENABLEOK, 0, (LPARAM)0); // disable
		char FolderName[MAX_PATH];
		SHGetPathFromIDList((LPITEMIDLIST) lParam, FolderName);
		
//		if (CreateFile(FolderName,STANDARD_RIGHTS_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL) == INVALID_HANDLE_VALUE)
		if ((GetFileAttributes(FolderName) & FILE_ATTRIBUTE_DIRECTORY) != 0)
			::SendMessage(hwnd, BFFM_ENABLEOK, 0, (LPARAM)1); // enable
		else
			::SendMessage(hwnd, BFFM_ENABLEOK, 0, (LPARAM)0); // disable
//ADbg tst;
//tst.OutPut("change folder to %s ",FolderName);
	}*/

	return 0;
}
#ifdef OLD
#endif // OLD

static BOOL CALLBACK ConfigProc(
  HWND hwndDlg,  // handle to dialog box
  UINT uMsg,     // message
  WPARAM wParam, // first message parameter
  LPARAM lParam  // second message parameter
  )
{
	BOOL bResult;

	switch (uMsg) {
		case WM_COMMAND:
			UINT command;
			command = GET_WM_COMMAND_ID(wParam, lParam);

            if (IDOK == command)
            {
				// save parameters
				AEncodeProperties * the_prop;
				the_prop = (AEncodeProperties *) GetProp(hwndDlg, "AEncodeProperties-Config");

				if (the_prop != NULL)
				{
					char string[MAX_PATH];
					::GetWindowText(::GetDlgItem( hwndDlg, IDC_COMBO_SETTINGS), string, MAX_PATH);

//					the_prop->SelectSavedParams(string);
					the_prop->UpdateDlgFromValue(hwndDlg);
					the_prop->SaveParams(hwndDlg);
				}

				RemoveProp(hwndDlg, "AEncodeProperties-Config");

                EndDialog(hwndDlg, (IDOK == command));
            } else if (IDCANCEL == command)
            {
				RemoveProp(hwndDlg, "AEncodeProperties-Config");
                EndDialog(hwndDlg, (IDOK == command));
            } else if (IDC_FIND_DLL == command)
			{
				AEncodeProperties * the_prop;
				the_prop = (AEncodeProperties *) GetProp(hwndDlg, "AEncodeProperties-Config");

				if (the_prop != NULL)
				{
					OPENFILENAME file;
					char DllLocation[512];
					wsprintf(DllLocation,"%s",the_prop->GetDllLocation());

					memset(&file, 0, sizeof(file));
					file.lStructSize = sizeof(file); 
					file.hwndOwner  = hwndDlg;
					file.Flags = OFN_FILEMUSTEXIST | OFN_NODEREFERENCELINKS | OFN_ENABLEHOOK | OFN_EXPLORER ;
///				file.lpstrFile = AOut::the_AOut->DllLocation;
					file.lpstrFile = DllLocation;
					file.lpstrFilter = "Lame DLL (lame_enc.dll)\0LAME_ENC.DLL\0DLL (*.dll)\0*.DLL\0All (*.*)\0*.*\0";
					file.nFilterIndex = 1;
					file.nMaxFile  = sizeof(DllLocation);
					file.lpfnHook  = DLLFindCallback; // use to validate the DLL chosen

					GetOpenFileName(&file);

					the_prop->SetDllLocation(DllLocation);
					// use this filename if necessary

//				AOut::the_AOut->the_Debug.OutPut(AOut::DllLocation);
				}
			} else if (IDC_BUTTON_OUTPUT == command)
			{
				AEncodeProperties * the_prop;
				the_prop = (AEncodeProperties *) GetProp(hwndDlg, "AEncodeProperties-Config");

//				ITEMIDLIST previous;
//				previous.

				BROWSEINFO info;
				memset(&info,0,sizeof(info));

				char FolderName[MAX_PATH];
/*				wsprintf( FolderName, the_prop->GetOutputDirectory());
ADbg tst;
tst.OutPut("Folder = %s",FolderName);

*/
				info.hwndOwner = hwndDlg;
				info.pszDisplayName  = FolderName;
				info.lpfn = BrowseFolderCallbackroc;
				info.lParam = (LPARAM) the_prop;

				TCHAR output[250];
				::LoadString(AOut::GetInstance(),IDS_STRING_DIR_SELECT,output,250);
				info.lpszTitle = output;

//				info.ulFlags = BIF_STATUSTEXT ;

/*				LPMALLOC pMalloc = NULL;
				SHGetMalloc(&pMalloc);

				LPITEMIDLIST pidlRoot = NULL;
//				SHGetFolderLocation(NULL,CSIDL_PERSONAL,NULL,0,&pidlRoot);
				SHGetSpecialFolderLocation(hwndDlg, CSIDL_PERSONAL,&pidlRoot);
				info.pidlRoot = pidlRoot;
*/
//tst.OutPut("Folder = %s",FolderName);
				ITEMIDLIST *item = SHBrowseForFolder(&info);
ADbg tst;
tst.OutPut("Folder = %s",FolderName);

/*
				if(pidlRoot)
				{
					pMalloc->Free(pidlRoot);
				}
				pMalloc->Release();
*/
    			if (item != NULL)
				{
					char tmpOutputDir[MAX_PATH];
					wsprintf(tmpOutputDir,"%s",the_prop->GetOutputDirectory());

					SHGetPathFromIDList(item,tmpOutputDir);
					the_prop->SetOutputDirectory(tmpOutputDir);
//					wsprintf(the_prop->OutputDir,FolderName);
tst.OutPut("Folder = %s",the_prop->GetOutputDirectory());
				}
else tst.OutPut("Folder not selected (%s)",FolderName);

#ifdef OLD
				OPENFILENAME file;

				memset(&file, 0, sizeof(file));
				file.lStructSize = sizeof(file); 
				file.hwndOwner  = hwndDlg;
				file.Flags = OFN_FILEMUSTEXIST | OFN_NODEREFERENCELINKS | OFN_ENABLEHOOK | OFN_EXPLORER ;
//				file.lpstrFile = the_prop->GetDllLocation();
//				file.lpstrFile = the_prop->GetOutputDirectory();
				file.lpstrInitialDir = the_prop->GetOutputDirectory();
//				file.lpstrFilter = "Lame DLL (lame_enc.dll)\0LAME_ENC.DLL\0DLL (*.dll)\0*.DLL\0All (*.*)\0*.*\0";
				file.lpstrFilter = "Dirs \0.*\0";
//				file.nFilterIndex = 1;
				file.nMaxFile  = the_prop->GetDllLocationSize();
				file.lpfnHook  = DLLFindCallback; // use to validate the DLL chosen
//				file.Flags = OFN_ENABLESIZING | OFN_NOREADONLYRETURN | OFN_HIDEREADONLY;
				file.Flags = OFN_NOREADONLYRETURN | OFN_HIDEREADONLY;

				TCHAR output[250];
				::LoadString(AOut::GetInstance(),IDS_STRING_DIR_SELECT,output,250);
				file.lpstrTitle = output;

//				GetOpenFileName(&file);
				GetSaveFileName(&file);

#endif // OLD
//				SetProp(hwndDlg, "FolderName", the_prop->GetOutputDirectory());

			} else if (IDC_CHECK_VBR == command)
			{
				AEncodeProperties * the_prop;
				the_prop = (AEncodeProperties *) GetProp(hwndDlg, "AEncodeProperties-Config");
				if (the_prop != NULL)
				{
					bool tmp_bVBRused = (SendMessage(GetDlgItem( hwndDlg, IDC_CHECK_VBR), BM_GETCHECK, NULL, NULL) == BST_CHECKED);
					if (tmp_bVBRused)
					{
						AEncodeProperties::DisplayVbrOptions(hwndDlg, true);
					}
					else
					{
						AEncodeProperties::DisplayVbrOptions(hwndDlg, false);
					}
//					the_prop->SetVBRUseMode(bVBRused);
				}

			} else if (IDC_CHECK_RESAMPLE == command)
			{
				bool tmp_bResampleUsed = (SendMessage(GetDlgItem( hwndDlg, IDC_CHECK_RESAMPLE), BM_GETCHECK, NULL, NULL) == BST_CHECKED);
				if (tmp_bResampleUsed)
				{
//					ShowWindow(GetDlgItem(hwndDlg,IDC_COMBO_SAMPLEFREQ),SW_SHOW);
					::EnableWindow(::GetDlgItem(hwndDlg,IDC_COMBO_SAMPLEFREQ), TRUE);
				}
				else
				{
//					ShowWindow(GetDlgItem(hwndDlg,IDC_COMBO_SAMPLEFREQ),SW_HIDE);
					::EnableWindow(::GetDlgItem(hwndDlg,IDC_COMBO_SAMPLEFREQ), FALSE);
				}
			} else if (IDC_SLIDER_QUALITY == command)
			{
				ADbg tst;
				tst.OutPut("cmd IDC_SLIDER_QUALITY");
			} else if (IDC_COMBO_SETTINGS == command)
			{
//				if (CBN_SELCHANGE == GET_WM_COMMAND_CMD(wParam, lParam))
				if (CBN_SELENDOK == GET_WM_COMMAND_CMD(wParam, lParam))
				{
					char string[MAX_PATH];
					int nIdx = SendMessage(HWND(lParam), CB_GETCURSEL, NULL, NULL);
					SendMessage(HWND(lParam), CB_GETLBTEXT , nIdx, (LPARAM) string);

					// get the info corresponding to the new selected item
					AEncodeProperties * the_prop;
					the_prop = (AEncodeProperties *) GetProp(hwndDlg, "AEncodeProperties-Config");
					if (the_prop != NULL)
					{
						the_prop->SelectSavedParams(string);
						the_prop->UpdateDlgFromValue(hwndDlg);
					}

				}
			} else if (IDC_BUTTON_CONFIG_SAVE == command)
			{
				// save the data in the current config
				AEncodeProperties * the_prop;
				the_prop = (AEncodeProperties *) GetProp(hwndDlg, "AEncodeProperties-Config");
				if (the_prop != NULL)
				{
					char string[MAX_PATH];
					::GetWindowText(::GetDlgItem( hwndDlg, IDC_COMBO_SETTINGS), string, MAX_PATH);

					the_prop->UpdateValueFromDlg(hwndDlg);
					the_prop->SaveValuesToStringKey(string);
				}
			}
/*			else
			{
				::OutputDebugString("unknown command");
			}
*/
			
			
            bResult = FALSE;
			break;
		case WM_INITDIALOG:
			AEncodeProperties * the_prop;

			the_prop = (AEncodeProperties *) lParam;

			the_prop->InitConfigDlg(hwndDlg);

			SetProp(hwndDlg, "AEncodeProperties-Config", the_prop);

			bResult = TRUE;
			break;
/*		case WM_NOTIFY:
			{
			ADbg tst;
			tst.OutPut("msg WM_NOTIFY");
			}
			break;*/
		case WM_HSCROLL:
			// check if it's the Quality slider
			if ((HWND)lParam == GetDlgItem(hwndDlg,IDC_SLIDER_QUALITY))
			{
//				ADbg tst;
//				tst.OutPut("msg WM_NOTIFY %d/%d / %08X / %08X / %08X",LOWORD(wParam),HIWORD(wParam),lParam,hwndDlg,GetDlgItem(hwndDlg,IDC_SLIDER_QUALITY));
				
				AEncodeProperties * the_prop;
				the_prop = (AEncodeProperties *) GetProp(hwndDlg, "AEncodeProperties-Config");
				if (the_prop != NULL)
				{
					UINT VbrQuality = SendMessage(GetDlgItem( hwndDlg, IDC_SLIDER_QUALITY), TBM_GETPOS, NULL, NULL);
					char tmp[2];
					wsprintf(tmp,"%d",VbrQuality);
					::SetWindowText(GetDlgItem( hwndDlg, IDC_CONFIG_QUALITY), tmp);
				}
			}
			break;
		default:
			bResult = FALSE; // will be treated by DefWindowProc
	}
	return bResult;
}

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

const char * AEncodeProperties::GetChannelModeString(int a_channelID) const
{
	assert(nChannelIndex < sizeof(the_ChannelModes));

	switch (a_channelID) {
		case 0:
			return "Mono";
		case 1:
			return "Stereo";
		case 2:
			return "Joint-stereo";
		default:
			return "Dual Channel";
	}
}

const int AEncodeProperties::GetBitrateString(char * string, int string_size, int a_bitrateID) const
{
	assert(a_bitrateID < sizeof(the_Bitrates));

	if (string != NULL)
		return wsprintf(string,"%d",the_Bitrates[a_bitrateID]);
	else
		return -1;
}

const unsigned int AEncodeProperties::GetChannelModeValue() const
{
	assert(nChannelIndex < sizeof(the_ChannelModes));

	return the_ChannelModes[nChannelIndex];
}

const unsigned int AEncodeProperties::GetBitrateValue() const
{
	assert(nMinBitrateIndex < sizeof(the_Bitrates));

	return the_Bitrates[nMinBitrateIndex];
}

inline const int AEncodeProperties::GetBitrateValueMPEG2(DWORD & bitrate) const
{
	int i;

	for (i=0;i<sizeof(the_MPEG2_Bitrates)/sizeof(unsigned int);i++)
	{
		if (the_MPEG2_Bitrates[i] == the_Bitrates[nMinBitrateIndex])
		{
			bitrate = the_MPEG2_Bitrates[i];
			return 0;
		}
		else if (the_MPEG2_Bitrates[i] < the_Bitrates[nMinBitrateIndex])
		{
			bitrate = the_MPEG2_Bitrates[i];
			return -1;
		}
	}
	
	bitrate = 160;
	return -1;
}

inline const int AEncodeProperties::GetBitrateValueMPEG1(DWORD & bitrate) const
{
	int i;

	for (i=sizeof(the_MPEG1_Bitrates)/sizeof(unsigned int)-1;i>=0;i--)
	{
		if (the_MPEG1_Bitrates[i] == the_Bitrates[nMinBitrateIndex])
		{
			bitrate = the_MPEG1_Bitrates[i];
			return 0;
		}
		else if (the_MPEG1_Bitrates[i] > the_Bitrates[nMinBitrateIndex])
		{
			bitrate = the_MPEG1_Bitrates[i];
			return 1;
		}
	}
	
	bitrate = 32;
	return 1;
}

const int AEncodeProperties::GetBitrateValue(DWORD & bitrate, const DWORD MPEG_Version) const
{
	assert((MPEG_Version == MPEG1) || (MPEG_Version == MPEG2));
	assert(nMinBitrateIndex < sizeof(the_Bitrates));

	if (MPEG_Version == MPEG2)
		return GetBitrateValueMPEG2(bitrate);
	else
		return GetBitrateValueMPEG1(bitrate);
}

const char * AEncodeProperties::GetPresetModeString(const int a_presetID) const
{
	assert(nPresetIndex < sizeof(the_Presets));

	switch (a_presetID) {
		case 1:
			return "Normal";
		case 2:
			return "Low";
		case 3:
			return "High";
		case 4:
			return "Voice";
		case 5:
			return "Phone";
		case 6:
			return "SW";
		case 7:
			return "AM";
		case 8:
			return "FM";
		case 9:
			return "Voice";
		case 10:
			return "Radio";
		case 11:
			return "Tape";
		case 12:
			return "Hi-Fi";
		case 13:
			return "CD";
		case 14:
			return "Studio";
		default:
			return "None";
	}
}

const LAME_QUALTIY_PRESET AEncodeProperties::GetPresetModeValue() const
{
	assert(nPresetIndex < sizeof(the_Presets));

	return the_Presets[nPresetIndex];
}

bool AEncodeProperties::Config(const HINSTANCE Hinstance, const HWND HwndParent)
{
	//WM_INITDIALOG ?

	// remember the instance to retreive strings
	hDllInstance = Hinstance;

	return (::DialogBoxParam(Hinstance, MAKEINTRESOURCE(IDD_CONFIG), HwndParent, ::ConfigProc, (LPARAM) this) == 1);
}

bool AEncodeProperties::InitConfigDlg(HWND HwndDlg)
{
	// get all the required strings
//	TCHAR Version[5];
//	LoadString(hDllInstance, IDS_STRING_VERSION, Version, 5);

	int i;

	// Check boxes if required
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_CRC),       BM_SETCHECK, GetCRCMode()      ?BST_CHECKED:BST_UNCHECKED, NULL);
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_ORIGINAL),  BM_SETCHECK, GetOriginalMode() ?BST_CHECKED:BST_UNCHECKED, NULL);
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_PRIVATE),   BM_SETCHECK, GetPrivateMode()  ?BST_CHECKED:BST_UNCHECKED, NULL);
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_COPYRIGHT), BM_SETCHECK, GetCopyrightMode()?BST_CHECKED:BST_UNCHECKED, NULL);
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_RESERVOIR), BM_SETCHECK, !GetNoBiResMode() ?BST_CHECKED:BST_UNCHECKED, NULL);
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_VBR),       BM_SETCHECK, GetVBRUseMode()   ?BST_CHECKED:BST_UNCHECKED, NULL);
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_XINGVBR),   BM_SETCHECK, GetXingFrameMode()?BST_CHECKED:BST_UNCHECKED, NULL);
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_RESAMPLE),  BM_SETCHECK, GetResampleMode() ?BST_CHECKED:BST_UNCHECKED, NULL);

	// Add required channel modes
	SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_CHANNELS), CB_RESETCONTENT , NULL, NULL);
	for (i=0;i<GetChannelLentgh();i++)
		SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_CHANNELS), CB_ADDSTRING, NULL, (LPARAM) GetChannelModeString(i));

	for (i=0;i<GetChannelLentgh();i++)
	{
		if (i == nChannelIndex)
		{
			SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_CHANNELS), CB_SETCURSEL, i, NULL);
			break;
		}
	}

	// Add all possible re-sampling freq
	SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_SAMPLEFREQ), CB_RESETCONTENT , NULL, NULL);
	char tmp[10];
	for (i=0;i<sizeof(the_SamplingFreqs)/sizeof(unsigned int);i++)
	{
		wsprintf(tmp, "%d", the_SamplingFreqs[i]);
		SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_SAMPLEFREQ), CB_ADDSTRING, NULL, (LPARAM) tmp );
	}
	SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_SAMPLEFREQ), CB_SETCURSEL, nSamplingFreqIndex, NULL);
	

	// Add required bitrates
	SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_BITRATE), CB_RESETCONTENT , NULL, NULL);
	for (i=0;i<GetBitrateLentgh();i++)
	{
		GetBitrateString(tmp, 5, i);
		SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_BITRATE), CB_ADDSTRING, NULL, (LPARAM) tmp );
	}

	for (i=0;i<GetBitrateLentgh();i++)
	{
		if (i == nMinBitrateIndex)
		{
			SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_BITRATE), CB_SETCURSEL, i, NULL);
			break;
		}
	}

	// Add bitrates to the VBR combo box too
	SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_MAXBITRATE), CB_RESETCONTENT , NULL, NULL);
	for (i=0;i<GetBitrateLentgh();i++)
	{
		GetBitrateString(tmp, 5, i);
		SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_MAXBITRATE), CB_ADDSTRING, NULL, (LPARAM) tmp );
	}

	for (i=0;i<GetBitrateLentgh();i++)
	{
		if (i == nMaxBitrateIndex)
		{
			SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_MAXBITRATE), CB_SETCURSEL, i, NULL);
			break;
		}
	}

	// Add VBR Quality
	SendMessage(GetDlgItem( HwndDlg, IDC_SLIDER_QUALITY), TBM_SETRANGE, TRUE, MAKELONG(0,9));

	wsprintf(tmp,"%d",VbrQuality);
	SetWindowText(GetDlgItem( HwndDlg, IDC_CONFIG_QUALITY), tmp);
	SendMessage(GetDlgItem( HwndDlg, IDC_SLIDER_QUALITY), TBM_SETPOS, TRUE, VbrQuality);
	
	
	// Display VBR settings if needed
	if (GetVBRUseMode())
	{
		AEncodeProperties;;DisplayVbrOptions(HwndDlg, true);
	}
	else
	{
		AEncodeProperties;;DisplayVbrOptions(HwndDlg, false);
	}

	// Display Resample settings if needed
	if (GetResampleMode())
	{
		::EnableWindow(::GetDlgItem(HwndDlg,IDC_COMBO_SAMPLEFREQ), TRUE);
	}
	else
	{
		::EnableWindow(::GetDlgItem(HwndDlg,IDC_COMBO_SAMPLEFREQ), FALSE);
	}


	// Add presets
	SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_PRESET), CB_RESETCONTENT , NULL, NULL);
	for (i=0;i<GetPresetLentgh();i++)
		SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_PRESET), CB_ADDSTRING, NULL, (LPARAM) GetPresetModeString(i));

	for (i=0;i<GetPresetLentgh();i++)
	{
		if (i == nPresetIndex)
		{
			SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_PRESET), CB_SETCURSEL, i, NULL);
			break;
		}
	}

	// Add User configs
	SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_SETTINGS), CB_RESETCONTENT , NULL, NULL);

	// display all the names of the saved configs
	// get the values from the saved file if possible
	if (my_stored_data.LoadFile(my_store_location))
	{
		TiXmlNode* node;

		node = my_stored_data.FirstChild("out_lame");

		TiXmlElement* CurrentNode = node->FirstChildElement("configs");

		std::string CurrentConfig = "";

		if (CurrentNode->Attribute("default") != NULL)
		{
			CurrentConfig = *CurrentNode->Attribute("default");
		}

		TiXmlElement* iterateElmt;

		// find the config that correspond to CurrentConfig
		iterateElmt = CurrentNode->FirstChildElement("config");
		int Idx = 0;
		while (iterateElmt != NULL)
		{
			const std::string * tmpname = iterateElmt->Attribute("name");
			// TODO support language names
			if (tmpname != NULL)
			{
				SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_SETTINGS), CB_ADDSTRING, NULL, (LPARAM) tmpname->c_str());
				if (tmpname->compare(CurrentConfig) == 0)
				{
					SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_SETTINGS), CB_SETCURSEL, Idx, NULL);
				}
			}
			Idx++;
			iterateElmt = iterateElmt->NextSiblingElement("config");
		}
	}

	return true;
}

bool AEncodeProperties::UpdateDlgFromValue(HWND HwndDlg)
{
	// get all the required strings
//	TCHAR Version[5];
//	LoadString(hDllInstance, IDS_STRING_VERSION, Version, 5);

	int i;

	// Check boxes if required
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_CRC),       BM_SETCHECK, GetCRCMode()      ?BST_CHECKED:BST_UNCHECKED, NULL);
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_ORIGINAL),  BM_SETCHECK, GetOriginalMode() ?BST_CHECKED:BST_UNCHECKED, NULL);
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_PRIVATE),   BM_SETCHECK, GetPrivateMode()  ?BST_CHECKED:BST_UNCHECKED, NULL);
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_COPYRIGHT), BM_SETCHECK, GetCopyrightMode()?BST_CHECKED:BST_UNCHECKED, NULL);
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_RESERVOIR), BM_SETCHECK, !GetNoBiResMode() ?BST_CHECKED:BST_UNCHECKED, NULL);
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_VBR),       BM_SETCHECK, GetVBRUseMode()   ?BST_CHECKED:BST_UNCHECKED, NULL);
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_XINGVBR),   BM_SETCHECK, GetXingFrameMode()?BST_CHECKED:BST_UNCHECKED, NULL);
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_RESAMPLE),  BM_SETCHECK, GetResampleMode() ?BST_CHECKED:BST_UNCHECKED, NULL);

	// Add required channel modes
	for (i=0;i<GetChannelLentgh();i++)
	{
		if (i == nChannelIndex)
		{
			SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_CHANNELS), CB_SETCURSEL, i, NULL);
			break;
		}
	}

	// Add all possible re-sampling freq
	SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_SAMPLEFREQ), CB_SETCURSEL, nSamplingFreqIndex, NULL);
	

	// Add required bitrates
	for (i=0;i<GetBitrateLentgh();i++)
	{
		if (i == nMinBitrateIndex)
		{
			SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_BITRATE), CB_SETCURSEL, i, NULL);
			break;
		}
	}

	// Add bitrates to the VBR combo box too
	for (i=0;i<GetBitrateLentgh();i++)
	{
		if (i == nMaxBitrateIndex)
		{
			SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_MAXBITRATE), CB_SETCURSEL, i, NULL);
			break;
		}
	}

	// Add VBR Quality
//	SendMessage(GetDlgItem( HwndDlg, IDC_SLIDER_QUALITY), TBM_SETRANGE, TRUE, MAKELONG(0,9));

	char tmp[3];
	wsprintf(tmp,"%d",VbrQuality);
	SetWindowText(GetDlgItem( HwndDlg, IDC_CONFIG_QUALITY), tmp);
	SendMessage(GetDlgItem( HwndDlg, IDC_SLIDER_QUALITY), TBM_SETPOS, TRUE, VbrQuality);
	
	
	// Display VBR settings if needed
	if (GetVBRUseMode())
	{
		AEncodeProperties;;DisplayVbrOptions(HwndDlg, true);
	}
	else
	{
		AEncodeProperties;;DisplayVbrOptions(HwndDlg, false);
	}

	// Display Resample settings if needed
	if (GetResampleMode())
	{
		::EnableWindow(::GetDlgItem(HwndDlg,IDC_COMBO_SAMPLEFREQ), TRUE);
	}
	else
	{
		::EnableWindow(::GetDlgItem(HwndDlg,IDC_COMBO_SAMPLEFREQ), FALSE);
	}


	// Add presets
	for (i=0;i<GetPresetLentgh();i++)
	{
		if (i == nPresetIndex)
		{
			SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_PRESET), CB_SETCURSEL, i, NULL);
			break;
		}
	}

	// Add User configs
//	SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_SETTINGS), CB_RESETCONTENT , NULL, NULL);

	// TODO
	// Select the right saved config
#ifdef OLD
	AParameters prms;

	prms.Attach("SOFTWARE\\MUKOLI\\out_lame\\Configs");

	char currentName[MAX_PATH];
	unsigned long DSize = MAX_PATH;
	prms.QueryValue("current", currentName, DSize);

	char string[MAX_PATH];

//	int i=0;
	while (prms.NextSubKey( string, MAX_PATH) == AParameters::KEY_FOUND)
	{
		AParameters * tmpkey = prms.GetSubKey(string);

		char string2[MAX_PATH];
		unsigned long DSize = MAX_PATH;

		tmpkey->QueryValue("Name", string2, DSize);
//		SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_SETTINGS), CB_ADDSTRING, NULL, (LPARAM) string2);
		prms.ReleaseSubKey(tmpkey);

		if (strcmp(string,currentName) == 0)
		{
			SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_SETTINGS), CB_SETCURSEL, i, NULL);
			break;
		}

		i++;
	}

	prms.Detach();
#endif // OLD

	return true;
}

bool AEncodeProperties::UpdateValueFromDlg(HWND HwndDlg)
{
	nChannelIndex      = SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_CHANNELS),   CB_GETCURSEL, NULL, NULL);
	nMinBitrateIndex   = SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_BITRATE),    CB_GETCURSEL, NULL, NULL);
	nMaxBitrateIndex   = SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_MAXBITRATE), CB_GETCURSEL, NULL, NULL);
	nPresetIndex       = SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_PRESET),     CB_GETCURSEL, NULL, NULL);
	VbrQuality         = SendMessage(GetDlgItem( HwndDlg, IDC_SLIDER_QUALITY), TBM_GETPOS , NULL, NULL);
	nSamplingFreqIndex = SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_SAMPLEFREQ), CB_GETCURSEL, NULL, NULL);

	bCRC       = (SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_CRC),       BM_GETCHECK, NULL, NULL) == BST_CHECKED);
	bCopyright = (SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_COPYRIGHT), BM_GETCHECK, NULL, NULL) == BST_CHECKED);
	bOriginal  = (SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_ORIGINAL),  BM_GETCHECK, NULL, NULL) == BST_CHECKED);
	bPrivate   = (SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_PRIVATE),   BM_GETCHECK, NULL, NULL) == BST_CHECKED);
	bNoBitRes  =!(SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_RESERVOIR), BM_GETCHECK, NULL, NULL) == BST_CHECKED);
	bVBRused   = (SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_VBR),       BM_GETCHECK, NULL, NULL) == BST_CHECKED);
	bXingFrame = (SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_XINGVBR),   BM_GETCHECK, NULL, NULL) == BST_CHECKED);
	bResample  = (SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_RESAMPLE),  BM_GETCHECK, NULL, NULL) == BST_CHECKED);

//this->output();
//::OutputDebugString(" ");

	return true;
}

bool AEncodeProperties::GetVBRValue(DWORD & MaxBitrate, int & Quality, BOOL & VBRHeader, const DWORD MPEG_Version) const
{
	assert((MPEG_Version == MPEG1) || (MPEG_Version == MPEG2));
	assert(nMaxBitrateIndex < sizeof(the_Bitrates));

	if (bVBRused)
	{
		MaxBitrate = the_Bitrates[nMaxBitrateIndex];

		if (MPEG_Version == MPEG1)
			MaxBitrate = max(MaxBitrate, the_MPEG1_Bitrates[sizeof(the_MPEG1_Bitrates)/sizeof(unsigned int)-1]);
		else
			MaxBitrate = min(MaxBitrate, the_MPEG2_Bitrates[0]);

		VBRHeader = bXingFrame;
		Quality = VbrQuality;
	}

	return bVBRused;

}

void AEncodeProperties::ParamsRestore()
{
	// use these default parameters in case one is not found
	bCopyright    = true;
	bCRC          = true;
	bOriginal     = true;
	bPrivate      = true;
	bNoBitRes     = false; // enable bit reservoir
	bVBRused      = false;
	bXingFrame    = true;
	bResample     = false;
	bForceChannel = false;

	nChannelIndex = 2; // joint-stereo
	nMinBitrateIndex = 6; // 128 kbps (works for both MPEGI and II)
	nMaxBitrateIndex = 4; // 160 kbps (works for both MPEGI and II)
	nPresetIndex = 0; // None
	VbrQuality = 1; // Quite High
	nSamplingFreqIndex = 1; // 44100

	OutputDir = "c:\\";

	DllLocation = "plugins\\lame_enc.dll";

	// get the values from the saved file if possible
	if (my_stored_data.LoadFile(my_store_location))
	{
		TiXmlNode* node;

		node = my_stored_data.FirstChild("out_lame");

		TiXmlElement* CurrentNode = node->FirstChildElement("configs");

		std::string CurrentConfig = "";

		if (CurrentNode->Attribute("default") != NULL)
		{
			CurrentConfig = *CurrentNode->Attribute("default");
		}

		// output parameters
		TiXmlElement* iterateElmt = node->FirstChildElement("DLL");
		if (iterateElmt != NULL)
		{
			const std::string * tmpname = iterateElmt->Attribute("location");
			if (tmpname != NULL)
			{
				DllLocation = *tmpname;
			}
		}

		GetValuesFromKey(CurrentConfig, *CurrentNode);
	}
	else
	{
		// TODO
		// save the data in the file !
	}
}

void AEncodeProperties::ParamsSave()
{
/*


	save the current parameters in the corresponding subkey
	



	HKEY OssKey;

	if (RegCreateKeyEx ( HKEY_LOCAL_MACHINE, "SOFTWARE\\MUKOLI\\out_lame", 0, "", REG_OPTION_NON_VOLATILE, KEY_WRITE , NULL, &OssKey, NULL ) == ERROR_SUCCESS) {

		if (RegSetValueEx(OssKey, "DLL Location", 0, REG_EXPAND_SZ, (CONST BYTE *)DllLocation, strlen(DllLocation)+1 ) != ERROR_SUCCESS)
			return;
		
		RegCloseKey(OssKey); 
	}
*/
}

void AEncodeProperties::DisplayVbrOptions(HWND hDialog, bool bValue)
{
	if(bValue)
	{
		::SetWindowText(::GetDlgItem(hDialog,IDC_STATIC_MINBITRATE), "Min Bitrate");
	}
	else
	{
		::SetWindowText(::GetDlgItem(hDialog,IDC_STATIC_MINBITRATE), "Bitrate");
	}

	::EnableWindow(::GetDlgItem( hDialog, IDC_CHECK_XINGVBR), bValue);

	::EnableWindow(::GetDlgItem( hDialog, IDC_COMBO_MAXBITRATE), bValue);

	::EnableWindow(::GetDlgItem( hDialog, IDC_STATIC_MAXBITRATE), bValue);

	::EnableWindow(::GetDlgItem( hDialog, IDC_SLIDER_QUALITY), bValue);

	::EnableWindow(::GetDlgItem( hDialog, IDC_CONFIG_QUALITY), bValue);

	::EnableWindow(::GetDlgItem( hDialog, IDC_STATIC_VBRQUALITY), bValue);

	::EnableWindow(::GetDlgItem( hDialog, IDC_STATIC_VBRQUALITY_LOW), bValue);

	::EnableWindow(::GetDlgItem( hDialog, IDC_STATIC_VBRQUALITY_HIGH), bValue);

}

AEncodeProperties::AEncodeProperties()
{
//	my_tst = tst;
//	tst++;

	std::string path = "";
	HMODULE htmp = LoadLibrary("out_lame.dll");
	if (htmp != NULL)
	{
		char output[MAX_PATH];
		::GetModuleFileName(htmp, output, MAX_PATH);
		::FreeLibrary(htmp);

		path = output;
	}
	my_store_location = path.substr(0,path.find_last_of('\\')+1);
	my_store_location += "out_lame.xml";
	::OutputDebugString(my_store_location.c_str());

	// make sure the XML file is present
	HANDLE hFile = ::CreateFile(my_store_location.c_str(), 0, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_ARCHIVE, NULL );
	::CloseHandle(hFile);
}

// Save the values to the right XML saved config
void AEncodeProperties::SaveValuesToStringKey(const std::string & config_name)
{
	// get the current data in the file to keep them
	if (my_stored_data.LoadFile(my_store_location))
	{
		// check if the Node corresponding to the config_name already exist.
		TiXmlNode* node = my_stored_data.FirstChild("out_lame");

		if (node != NULL)
		{
			TiXmlElement* ConfigNode = node->FirstChildElement("configs");

			if (ConfigNode != NULL)
			{
				// look all the <config> tags
				TiXmlElement* tmpNode = ConfigNode->FirstChildElement("config");
				while (tmpNode != NULL)
				{
					const std::string * tmpname = tmpNode->Attribute("name");
					if (tmpname->compare(config_name) == 0)
					{
						break;
					}
					tmpNode = tmpNode->NextSiblingElement("config");
				}

				if (tmpNode == NULL)
				{
					// Create the node
					tmpNode = new TiXmlElement("config");
					tmpNode->SetAttribute("name",config_name);

					// save data in the node
					SaveValuesToElement(tmpNode);

					ConfigNode->InsertEndChild(*tmpNode);
				}
				else
				{
					// save data in the node
					SaveValuesToElement(tmpNode);
				}


				// and save the file
				my_stored_data.SaveFile(my_store_location);
			}
		}
	}
}

void AEncodeProperties::GetValuesFromKey(const std::string & config_name, const TiXmlNode & parentNode)
{
	TiXmlElement* tmpElt;
	TiXmlElement* iterateElmt;

	// find the config that correspond to CurrentConfig
	iterateElmt = parentNode.FirstChildElement("config");
	while (iterateElmt != NULL)
	{
		const std::string * tmpname = iterateElmt->Attribute("name");
		if ((tmpname != NULL) && (tmpname->compare(config_name) == 0))
		{
			break;
		}
		iterateElmt = iterateElmt->NextSiblingElement("config");
	}

	if (iterateElmt != NULL)
	{
		// get all the parameters saved in this Element
		const std::string * tmpname;

		// Copyright parameter
		tmpElt = iterateElmt->FirstChildElement("Copyright");
		if (tmpElt != NULL)
		{
			tmpname = tmpElt->Attribute("use");
			if (tmpname != NULL)
				bCopyright = (tmpname->compare("true") == 0);
		}

		// Copyright parameter
		tmpElt = iterateElmt->FirstChildElement("CRC");
		if (tmpElt != NULL)
		{
			tmpname = tmpElt->Attribute("use");
			if (tmpname != NULL)
				bCRC = (tmpname->compare("true") == 0);
		}

		// Copyright parameter
		tmpElt = iterateElmt->FirstChildElement("Original");
		if (tmpElt != NULL)
		{
			tmpname = tmpElt->Attribute("use");
			if (tmpname != NULL)
				bOriginal = (tmpname->compare("true") == 0);
		}

		// Copyright parameter
		tmpElt = iterateElmt->FirstChildElement("Private");
		if (tmpElt != NULL)
		{
			tmpname = tmpElt->Attribute("use");
			if (tmpname != NULL)
				bPrivate = (tmpname->compare("true") == 0);
		}

		// Copyright parameter
		tmpElt = iterateElmt->FirstChildElement("Bit_reservoir");
		if (tmpElt != NULL)
		{
			tmpname = tmpElt->Attribute("use");
			if (tmpname != NULL)
				bNoBitRes = !(tmpname->compare("true") == 0);
		}

		// bitrates
		tmpElt = iterateElmt->FirstChildElement("bitrate");
		tmpname = tmpElt->Attribute("min");
		if (tmpname != NULL)
		{
			unsigned int uitmp = atoi(tmpname->c_str());
			for (int i=0;i<sizeof(the_Bitrates)/sizeof(unsigned int);i++)
			{
				if (the_Bitrates[i] == uitmp)
				{
					nMinBitrateIndex = i;
					break;
				}
			}
		}

		tmpname = tmpElt->Attribute("max");
		if (tmpname != NULL)
		{
			unsigned int uitmp = atoi(tmpname->c_str());
			for (int i=0;i<sizeof(the_Bitrates)/sizeof(unsigned int);i++)
			{
				if (the_Bitrates[i] == uitmp)
				{
					nMaxBitrateIndex = i;
					break;
				}
			}
		}

		// resampling parameters
		tmpElt = iterateElmt->FirstChildElement("resampling");
		if (tmpElt != NULL)
		{
			tmpname = tmpElt->Attribute("use");
			if (tmpname != NULL)
				bResample = (tmpname->compare("true") == 0);

			unsigned int uitmp = atoi(tmpElt->Attribute("freq")->c_str());
			for (int i=0;i<sizeof(the_SamplingFreqs)/sizeof(unsigned int);i++)
			{
				if (the_SamplingFreqs[i] == uitmp)
				{
					nSamplingFreqIndex = i;
					break;
				}
			}
		}

		// VBR parameters
		tmpElt = iterateElmt->FirstChildElement("VBR");
		if (tmpElt != NULL)
		{
			tmpname = tmpElt->Attribute("use");
			if (tmpname != NULL)
				bVBRused = (tmpname->compare("true") == 0);

			tmpname = tmpElt->Attribute("header");
			if (tmpname != NULL)
				bXingFrame = (tmpname->compare("true") == 0);

			tmpname = tmpElt->Attribute("quality");
			if (tmpname != NULL)
			{
				VbrQuality = atoi(tmpname->c_str());
			}
		}

		// output parameters
		tmpElt = iterateElmt->FirstChildElement("output");
		if (tmpElt != NULL)
		{
			OutputDir = *tmpElt->Attribute("path");
		}

		// Channel mode parameter
		tmpElt = iterateElmt->FirstChildElement("Channel");
		if (tmpElt != NULL)
		{
			const std::string * tmpStr = tmpElt->Attribute("mode");
			for (int i=0;i<GetChannelLentgh();i++)
			{
				if (tmpStr->compare(GetChannelModeString(i)) == 0)
				{
					nChannelIndex = i;
					break;
				}
			}

			tmpname = tmpElt->Attribute("force");
			if (tmpname != NULL)
				bForceChannel = (tmpname->compare("true") == 0);
		}

		// Preset parameter
		tmpElt = iterateElmt->FirstChildElement("Preset");
		if (tmpElt != NULL)
		{
			const std::string * tmpStr = tmpElt->Attribute("type");
			for (int i=0;i<GetPresetLentgh();i++)
			{
				if (tmpStr->compare(GetPresetModeString(i)) == 0)
				{
					nPresetIndex = i;
					break;
				}
			}

		}

	}
}

void AEncodeProperties::SaveParams(const HWND hParentWnd)
{
	char string[MAX_PATH];
	int nIdx = SendMessage(::GetDlgItem( hParentWnd ,IDC_COMBO_SETTINGS ), CB_GETCURSEL, NULL, NULL);
	::SendMessage(::GetDlgItem( hParentWnd ,IDC_COMBO_SETTINGS ), CB_GETLBTEXT , nIdx, (LPARAM) string);

	// TODO
	// save the parameters
#ifdef OLD
	AParameters prms;

	prms.Attach("SOFTWARE\\MUKOLI\\out_lame\\Configs");
	prms.ResetSubKey();

	bool bFound = false;
	char keystring[MAX_PATH];
	AParameters * subkey;
	char keyName[MAX_PATH];
	while (prms.NextSubKey(keystring, MAX_PATH) == AParameters::KEY_FOUND)
	{
		subkey = prms.GetSubKey(keystring);
		unsigned long DSize = MAX_PATH;
		subkey->QueryValue("Name", keyName, DSize);

		if (strcmp(keyName,string) == 0)
		{
/*			AEncodeProperties * the_prop;
			the_prop = (AEncodeProperties *) GetProp(hwndDlg, "AEncodeProperties-Config");

			the_prop->GetValuesFromKey(*subkey);
			the_prop->UpdateDlgFromValue(hwndDlg);
			prms.ReleaseSubKey(subkey);
			break;*/
//			prms.ReleaseSubKey(subkey);
			bFound = true;
			break;
		}

		prms.ReleaseSubKey(subkey);
	}

	assert(bFound);

	// update the "current" string in Registry with keystring
	prms.SetValueString("current",keystring);
		
//	prms.ReleaseSubKey(subkey);

//	prms.Detach();

	// if we are working with the 'current' key, just save it
	// otherwise prompt the user to save the parameters in the current key
	// if they are different from what is saved...
	if (strcmp(keystring,"Current") != 0)
	{
		AEncodeProperties tmpProperties; // used to compare with current values
		tmpProperties.GetValuesFromKey(*subkey);

		assert(should not use the subkey of another class...);

		if (tmpProperties != this)
		{
			TCHAR tmpout[250],output[250];
			::LoadString(AOut::GetInstance(),IDS_STRING_SAVE_PARAMS,tmpout,250);
			wsprintf(output,"%s\"%s\" ?",tmpout,keyName);
			if (::MessageBox( hParentWnd, output, "Winamp MP3 Output",MB_YESNO|MB_ICONQUESTION|MB_APPLMODAL) != IDYES)
			{
				// save in the 'current' key
				prms.SetValueString("current","Current");

				subkey = prms.GetSubKey("Current");
			}

			SaveValuesToKey(*subkey);
		}
tmpProperties.output();
this->output();

	}
	else
	{
		SaveValuesToKey(*subkey);
	}
	prms.ReleaseSubKey(subkey);

	prms.Detach();
#endif // OLD
}

bool AEncodeProperties::operator !=(const AEncodeProperties * the_instance) const
{

#ifdef _DEBUG
	this->output();
::OutputDebugString(" ");
	the_instance->output();
#endif // _DEBUG

	return ((this->bCopyright != the_instance->bCopyright)
		    || (this->bCRC != the_instance->bCRC)
		    || (this->bOriginal != the_instance->bOriginal)
		    || (this->bPrivate != the_instance->bPrivate)
		    || (this->bNoBitRes != the_instance->bNoBitRes)
		    || (this->bVBRused != the_instance->bVBRused)
		    || (this->bXingFrame != the_instance->bXingFrame)
		    || (this->bForceChannel != the_instance->bForceChannel)
		    || (this->bResample != the_instance->bResample)
		    || (this->nChannelIndex != the_instance->nChannelIndex)
		    || (this->nMinBitrateIndex != the_instance->nMinBitrateIndex)
		    || (this->nMaxBitrateIndex != the_instance->nMaxBitrateIndex)
		    || (this->nPresetIndex != the_instance->nPresetIndex)
		    || (this->VbrQuality != the_instance->VbrQuality)
		    || (this->nSamplingFreqIndex != the_instance->nSamplingFreqIndex)
			|| (this->OutputDir.compare(the_instance->OutputDir) != 0)
			);
}

#ifdef _DEBUG
void AEncodeProperties::output() const
{
	ADbg the_debug;
	the_debug.OutPut("my_tst = %d",my_tst);
	the_debug.OutPut("bNoBitRes is %s",bNoBitRes?"TRUE":"FALSE");
	the_debug.OutPut("bCopyright is %s",bCopyright?"TRUE":"FALSE");
	the_debug.OutPut("bCRC is %s",bCRC?"TRUE":"FALSE");
	the_debug.OutPut("bForceChannel is %s",bForceChannel?"TRUE":"FALSE");
	the_debug.OutPut("bOriginal is %s",bOriginal?"TRUE":"FALSE");
	the_debug.OutPut("bPrivate is %s",bPrivate?"TRUE":"FALSE");
	the_debug.OutPut("bVBRused is %s",bVBRused?"TRUE":"FALSE");
	the_debug.OutPut("bXingFrame is %s",bXingFrame?"TRUE":"FALSE");
}
#endif // _DEBUG

void AEncodeProperties::SelectSavedParams(const std::string the_string)
{
	// get the values from the saved file if possible
	if (my_stored_data.LoadFile(my_store_location))
	{
		TiXmlNode* node;

		node = my_stored_data.FirstChild("out_lame");

		TiXmlElement* CurrentNode = node->FirstChildElement("configs");

		if (CurrentNode != NULL)
		{
			CurrentNode->SetAttribute("default",the_string);
			GetValuesFromKey(the_string, *CurrentNode);
			my_stored_data.SaveFile(my_store_location);
		}
	}
}

void AEncodeProperties::SaveValuesToElement(TiXmlElement * the_element) const
{
	// get all the parameters saved in this Element
	TiXmlElement * tmpElt;

	// Bit Reservoir parameter
	tmpElt = the_element->FirstChildElement("Bit_reservoir");
	if (tmpElt == NULL)
	{
		tmpElt = new TiXmlElement("Bit_reservoir");
		tmpElt->SetAttributeBool("use", !bNoBitRes);
		the_element->InsertEndChild(*tmpElt);
	}
	else
	{
		tmpElt->SetAttributeBool("use", !bNoBitRes);
	}

	// Copyright parameter
	tmpElt = the_element->FirstChildElement("Copyright");
	if (tmpElt == NULL)
	{
		tmpElt = new TiXmlElement("Copyright");
		tmpElt->SetAttributeBool("use", bCopyright);
		the_element->InsertEndChild(*tmpElt);
	}
	else
	{
		tmpElt->SetAttributeBool("use", bCopyright);
	}

	// CRC parameter
	tmpElt = the_element->FirstChildElement("CRC");
	if (tmpElt == NULL)
	{
		tmpElt = new TiXmlElement("CRC");
		tmpElt->SetAttributeBool("use", bCRC);
		the_element->InsertEndChild(*tmpElt);
	}
	else
	{
		tmpElt->SetAttributeBool("use", bCRC);
	}

	// Original parameter
	tmpElt = the_element->FirstChildElement("Original");
	if (tmpElt == NULL)
	{
		tmpElt = new TiXmlElement("Original");
		tmpElt->SetAttributeBool("use", bOriginal);
		the_element->InsertEndChild(*tmpElt);
	}
	else
	{
		tmpElt->SetAttributeBool("use", bOriginal);
	}

	// Private parameter
	tmpElt = the_element->FirstChildElement("Private");
	if (tmpElt == NULL)
	{
		tmpElt = new TiXmlElement("Private");
		tmpElt->SetAttributeBool("use", bPrivate);
		the_element->InsertEndChild(*tmpElt);
	}
	else
	{
		tmpElt->SetAttributeBool("use", bPrivate);
	}

	// Channel Mode parameter
	tmpElt = the_element->FirstChildElement("Channel");
	if (tmpElt == NULL)
	{
		tmpElt = new TiXmlElement("Channel");
		tmpElt->SetAttribute("mode", GetChannelModeString(nChannelIndex));
		tmpElt->SetAttributeBool("force", bForceChannel);
		the_element->InsertEndChild(*tmpElt);
	}
	else
	{
		tmpElt->SetAttribute("mode", GetChannelModeString(nChannelIndex));
		tmpElt->SetAttributeBool("force", bForceChannel);
	}

	// Preset parameter
	tmpElt = the_element->FirstChildElement("Preset");
	if (tmpElt == NULL)
	{
		tmpElt = new TiXmlElement("Preset");
		tmpElt->SetAttribute("type", GetPresetModeString(nPresetIndex));
		the_element->InsertEndChild(*tmpElt);
	}
	else
	{
		tmpElt->SetAttribute("type", GetPresetModeString(nPresetIndex));
	}

	// Bitrate parameter
	tmpElt = the_element->FirstChildElement("bitrate");
	if (tmpElt == NULL)
	{
		tmpElt = new TiXmlElement("bitrate");
		tmpElt->SetAttribute("min", the_Bitrates[nMinBitrateIndex]);
		tmpElt->SetAttribute("max", the_Bitrates[nMaxBitrateIndex]);
		the_element->InsertEndChild(*tmpElt);
	}
	else
	{
		tmpElt->SetAttribute("min", the_Bitrates[nMinBitrateIndex]);
		tmpElt->SetAttribute("max", the_Bitrates[nMaxBitrateIndex]);
	}

	// Output Directory parameter
	tmpElt = the_element->FirstChildElement("output");
	if (tmpElt == NULL)
	{
		tmpElt = new TiXmlElement("output");
		tmpElt->SetAttribute("path", OutputDir);
		the_element->InsertEndChild(*tmpElt);
	}
	else
	{
		tmpElt->SetAttribute("path", OutputDir);
	}

	// Resampling parameter
	tmpElt = the_element->FirstChildElement("resampling");
	if (tmpElt == NULL)
	{
		tmpElt = new TiXmlElement("resampling");
		tmpElt->SetAttributeBool("use", bResample);
		tmpElt->SetAttribute("freq", the_SamplingFreqs[nSamplingFreqIndex]);
		the_element->InsertEndChild(*tmpElt);
	}
	else
	{
		tmpElt->SetAttributeBool("use", bResample);
		tmpElt->SetAttribute("freq", the_SamplingFreqs[nSamplingFreqIndex]);
	}

	// VBR parameter
	tmpElt = the_element->FirstChildElement("VBR");
	if (tmpElt == NULL)
	{
		tmpElt = new TiXmlElement("VBR");
		tmpElt->SetAttributeBool("use", bVBRused);
		tmpElt->SetAttributeBool("header", bXingFrame);
		tmpElt->SetAttribute("quality", VbrQuality);
		the_element->InsertEndChild(*tmpElt);
	}
	else
	{
		tmpElt->SetAttributeBool("use", bVBRused);
		tmpElt->SetAttributeBool("header", bXingFrame);
		tmpElt->SetAttribute("quality", VbrQuality);
	}

}
